#include<bits/stdc++.h>
#include <queue>
#include <set>

using namespace std;

int main() {
    int n, m, k;
    cin >> n >> m >> k;

    vector<vector<int>> g(n + 1);


    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }

    set<int> g;


    for (int i = 0; i < k; ++i) {
        int p, h;
        cin >> p >> h;


        vector<bool> s(n + 1, false);
        queue<pair<int, int>> q;
        q.push({p, 0});
        s[p] = true;
        while (!q.empty()) {
            auto [c, d] = q.front();
            q.pop();
            if (d > h) continue;
            g.insert(c);
            for (int r : g[c]) {
                if (!s[r]) {
                    s[r] = true;
                    q.push({r, d + 1});
                }
            }
        }
    }

    cout << g.size() << endl;
    if (!g.empty()) {
        vector<int> r(g.begin(), g.end());
        sort(r.begin(), r.end());
        for (int t : r) {
            cout << t << " ";
        }
        cout << endl;
    } else {
        cout << endl;
    }

}
