#include <bits/stdc++.h>
#include <queue>
#include <set>
#include <algorithm>

using namespace std;

int main() {
    long long n, m, k;
    cin >> n >> m >> k;
    vector<vector<long long>> gr(n + 1);


    for (long long i = 0; i < m; ++i) {
        long long a, b;
        cin >> a >> b;
        gr[a].push_back(b);
        gr[b].push_back(a);
    }

    set<long long> g;


    for (long long i = 0; i < k; ++i) {
        long long p, h;
        cin >> p >> h;


        vector<bool> v(n + 1, false);
        queue<pair<long long, long long>> q;
        q.push({p, 0});
        v[p] = true;

        while (!q.empty()) {
            auto [c, d] = q.front();
            q.pop();


            if (d > h) continue;

            g.insert(c);


            for (long long r : gr[c]) {
                if (!v[r]) {
                    v[r] = true;
                    q.push({r, d + 1});
                }
            }
        }
    }
    }
    if(m == 0){
        cout << 0;
    }
    else{
    cout << g.size() << endl;
    if (!g.empty()) {
        vector<long long> result(g.begin(), g.end());
        sort(result.begin(), result.end());
        for (long long war : result) {
            cout << war << " ";
        }
        cout << endl;
    } else {
        cout << endl;
    }
    }
}
